// Frontend.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Frontend.h"
#include "MapPropPage.h"
#include "PropPageOpenGL.h"
#include "TexturePropPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CFrontendApp

BEGIN_MESSAGE_MAP(CFrontendApp, CWinApp)
	ON_COMMAND(ID_HELP, OnHelp)
	ON_COMMAND(ID_HELP_FINDER, CWinApp::OnHelpFinder )
    ON_COMMAND(ID_CONTEXT_HELP, CWinApp::OnContextHelp)
    ON_COMMAND(ID_DEFAULT_HELP, CWinApp::OnHelpFinder)
END_MESSAGE_MAP()

// CFrontendApp construction

CFrontendApp::CFrontendApp()
{
	EnableHtmlHelp();
}


// The one and only CFrontendApp object

CFrontendApp theApp;

void CFrontendApp::OnHelp()
{
	::HtmlHelp(NULL, "FrontEnd.chm::/welcome.htm", HH_DISPLAY_TOPIC, 0);
}

// CFrontendApp initialization

BOOL CFrontendApp::InitInstance()
{
	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	CPropertySheet		dlg("Terrain Front End", NULL);
	MapPropPage			pgGeneral;
	PropPageOpenGL		pgOpenGL;
	ControlsPage		pgControls;
	CTexturePropPage	pgTexture;

	m_pMainWnd = &dlg;

	dlg.AddPage(&pgGeneral);
	dlg.AddPage(&pgTexture);
	dlg.AddPage(&pgOpenGL);
	dlg.AddPage(&pgControls);

	prefs.LoadConfig("terrain.ini");

#define PARAMETER(name, type, value, page)\
	pg ## page.name = prefs.GET_ ## type ##_PARAM(PARAM_##name);

#include "..\Source\params.h"
#undef PARAMETER

	INT_PTR nResponse = dlg.DoModal();
	::MessageBox(NULL, "couldn't write configuration", "error", MB_OK | MB_SYSTEMMODAL);
	if (nResponse == IDOK)
	{
		FILE *file;

		file = fopen("terrain.ini", "w");

		if (file)
		{

			fprintf(file, "# This file was automatically generated by TerrainFronted\n\n");

#define PARAMETER(name, type, value, page)\
			fprintf(file, "%s = ", #name);\
			switch (#type[0])\
			{\
			case 'I':\
				fprintf(file, "%d\n", pg ## page.name);\
				break;\
			case 'F':\
				fprintf(file, "%f\n", pg ## page.name);\
				break;\
			case 'S':\
				fprintf(file, "%s\n", pg ## page.name);\
				break;\
			default:\
				AfxMessageBox("warning, unknown param type");\
			}

#include "..\Source\params.h"
#undef PARAMETER
	
			fclose(file);

			STARTUPINFO si;
			PROCESS_INFORMATION pi;

			ZeroMemory(&si, sizeof(STARTUPINFO));
			si.cb = sizeof(STARTUPINFO);

			if (!CreateProcess("TerrainEngine.exe", NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
			{
				::MessageBox(NULL, "couldn't start engine", "error", MB_OK | MB_SYSTEMMODAL);
			}
		}
		else
		{
			::MessageBox(NULL, "couldn't write configuration", "error", MB_OK | MB_SYSTEMMODAL);
		}
	}
	else if (nResponse == IDCANCEL)
	{
	}
	::MessageBox(NULL, "couldn't write configuration", "error", MB_OK | MB_SYSTEMMODAL);

	return FALSE;
}

