// FrontendDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Frontend.h"
#include "FrontendDlg.h"
#include ".\frontenddlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
private:
	// load data from settings file
	int LoadSettings(void);
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFrontendDlg dialog



CFrontendDlg::CFrontendDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFrontendDlg::IDD, pParent)
	, use_arb_extension(FALSE)
	, benchmark_mode(FALSE)
	, use_compvarray(FALSE)
	, cull(FALSE)
	, mapname(_T(""))
	, fov(0)
	, fov_aspect(0)
	, freemove(FALSE)
	, fullscreen(FALSE)
	, mdraw(FALSE)
	, move_speed(0)
	, show_cull(FALSE)
	, varray(FALSE)
	, zfar(0)
	, znear(0)
	, none(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFrontendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_ARBCHECK, use_arb_extension);
	DDX_Check(pDX, IDC_BENCHMARKCHECK, benchmark_mode);
	DDX_Check(pDX, IDC_COMPVARRAYCHECK, use_compvarray);
	DDX_Check(pDX, IDC_CULLCHECK, cull);
	DDX_CBString(pDX, IDC_FILECOMBO, mapname);
	DDX_Text(pDX, IDC_FOV, fov);
	DDV_MinMaxFloat(pDX, fov, 20, 100);
	DDV_MaxChars(pDX, mapname, 256);
	DDX_Text(pDX, IDC_FOVASPECT, fov_aspect);
	DDX_Check(pDX, IDC_FREEMOVECHECK, freemove);
	DDX_Check(pDX, IDC_FULLSCREENCHECK, fullscreen);
	DDX_Check(pDX, IDC_MDRAWCHECK, mdraw);
	DDX_Text(pDX, IDC_MOVESPEED, move_speed);
	DDX_Check(pDX, IDC_SHOWCULLCHECK, show_cull);
	DDX_Check(pDX, IDC_VARRAYCHECK, varray);
	DDX_Text(pDX, IDC_ZFAR, zfar);
	DDX_Text(pDX, IDC_ZNEAR, znear);
}

BEGIN_MESSAGE_MAP(CFrontendDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_FILECOMBO, OnCbnSelchangeFilecombo)
END_MESSAGE_MAP()


// CFrontendDlg message handlers

BOOL CFrontendDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFrontendDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFrontendDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFrontendDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CFrontendDlg::OnCbnSelchangeFilecombo()
{
	// TODO: Add your control notification handler code here
}
