// MapPropPage.cpp : implementation file
//

#include "stdafx.h"
#include "Frontend.h"
#include "MapPropPage.h"
#include ".\mapproppage.h"
#include "loadbmp.h"

// MapPropPage dialog

IMPLEMENT_DYNAMIC(MapPropPage, CPropertyPage)
MapPropPage::MapPropPage()
	: CPropertyPage(MapPropPage::IDD)
	, FULLSCREEN(FALSE)
	, WIDTH(0)
	, HEIGHT(0)
	, BENCHMARK(FALSE)
	, SHOW_CULL(FALSE)
	, GLOBAL_DETAIL(0)
	, LOCAL_DETAIL(0)
	, MIN_DETAIL(0)
	, MAX_DETAIL(0)
	, FRUSTUM_CULLING(FALSE)
	, MAP_NAME(_T(""))
{
}

MapPropPage::~MapPropPage()
{
}

void MapPropPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_FULLSCREENCHECK, FULLSCREEN);
	DDX_Text(pDX, IDC_WIDTH, WIDTH);
	DDX_Text(pDX, IDC_HEIGHT, HEIGHT);
	DDX_Check(pDX, IDC_BENCHMARKCHECK, BENCHMARK);
	DDX_Check(pDX, IDC_SHOWCULLCHECK, SHOW_CULL);
	DDX_Text(pDX, IDC_GDETAIL, GLOBAL_DETAIL);
	DDX_Text(pDX, IDC_LDETAIL, LOCAL_DETAIL);
	DDX_Text(pDX, IDC_MINGDETAIL, MIN_DETAIL);
	DDX_Text(pDX, IDC_MAXGDETAIL, MAX_DETAIL);
	DDX_Check(pDX, IDC_CULLCHECK, FRUSTUM_CULLING);
	DDX_Control(pDX, IDC_STATICPIC, map_static);
	DDV_MinMaxFloat(pDX, GLOBAL_DETAIL, 1, 32);
	DDV_MinMaxFloat(pDX, LOCAL_DETAIL, 1, 32);
	DDV_MinMaxInt(pDX, MIN_DETAIL, 1, 32);
	DDV_MinMaxInt(pDX, MAX_DETAIL, 1, 32);
	DDV_MinMaxInt(pDX, WIDTH, 320, INT_MAX);
	DDV_MinMaxInt(pDX, HEIGHT, 200, INT_MAX);
	DDX_Text(pDX, IDC_FILEEDIT, MAP_NAME);
	DDV_MaxChars(pDX, MAP_NAME, 256);
	DDX_Control(pDX, IDC_FILEEDIT, FileEdit);
}


BEGIN_MESSAGE_MAP(MapPropPage, CPropertyPage)
	ON_BN_CLICKED(IDC_CULLCHECK, OnBnClickedCullcheck)
	ON_BN_CLICKED(IDC_SHOWCULLCHECK, OnBnClickedShowcullcheck)
	ON_BN_CLICKED(IDC_FILEBUTTON, OnBnClickedFilebutton)
	ON_EN_UPDATE(IDC_FILEEDIT, OnEnUpdateFileedit)
END_MESSAGE_MAP()


BOOL MapPropPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	MapPropPage::OnEnUpdateFileedit();

	return TRUE;
}
// MapPropPage message handlers

void MapPropPage::OnBnClickedCullcheck()
{
	if (!IsDlgButtonChecked(IDC_CULLCHECK))
	{
		CheckDlgButton(IDC_SHOWCULLCHECK, FALSE);
	}
}

void MapPropPage::OnBnClickedShowcullcheck()
{
	if (IsDlgButtonChecked(IDC_SHOWCULLCHECK))
	{
		CheckDlgButton(IDC_CULLCHECK, TRUE);
	}
}

void MapPropPage::OnBnClickedFilebutton()
{
	CFileDialog diag(TRUE, NULL, 0, OFN_HIDEREADONLY | 
		OFN_FILEMUSTEXIST | 
		OFN_NOCHANGEDIR,
		"Bitmaps (*.bmp)|*.bmp||", this);
	CString fname;

	if (diag.DoModal() == IDOK)
	{
		char dir[256];

		GetCurrentDirectory(256, dir);

		if ((CString(dir) + "\\" + diag.GetFileName()).CompareNoCase(diag.GetPathName()) != 0)
		{
			fname = diag.GetPathName();
			if (GetShortPathName(fname, dir, 256))
			{
				fname = dir;
			}
		}
		else
		{
			fname = diag.GetFileName();
		}
	}

	FileEdit.SetWindowText(fname);

}

void MapPropPage::OnEnUpdateFileedit()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.

	CString name;
	CBitmap *bmp;
	int res;

	FileEdit.GetWindowText(name);
	res = LoadBitmapFromFile(name.GetBuffer(), &bmp);
	if (res == BMP_MAP)
	{
		map_static.SetBitmap(*bmp);
	}
	else
	{
		if (res != BMP_LOAD_ERROR)
		{
			AfxMessageBox("map has to be 8 bit grayscale, square and of size 2**n+1");
		}
		map_static.SetBitmap(::LoadBitmap(theApp.m_hInstance, MAKEINTRESOURCE(IDB_FILENOTFOUND)));
	}

}
