/* abstract class definition */

#ifndef __GEZRENDERER_H__
#define __GEZRENDERER_H__

#include "Error.h"
#include "Console.h"
#include "Map.h"
#include "Vector.h"
#include "Preferences.h"

class Renderer
{
  private:
  protected:
    Console *console;
    Map     *map;
  public:
	bool texture;

    Renderer();
    ~Renderer();

	unsigned int vertices_count, triangles_count;
    
    virtual GEZERROR Initialize(Console &console, Preferences &params) = 0;
    virtual GEZERROR Render(const Vector3f &pos, const Vector3f &rot) = 0;

	virtual void IncreaseDetailLevel() = 0;
	virtual void DecreaseDetailLevel() = 0;
	virtual void IncreaseLocalDetailLevel() = 0;
	virtual void DecreaseLocalDetailLevel() = 0;
	virtual float GetDetailLevel() const = 0;
	virtual float GetLocalDetailLevel() const = 0;
  
    GEZERROR SetMap(Map *map);
        
    void SetConsole(Console *console);
};

#endif /* ifndef __GEZRENDERER_H__ */

