#include "Assert.h"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

int AssertFunction(int exp, char *desc, int line_nr, char* file, char *ignore)
{
    static char buf[256];
  
    wsprintf(buf, "%.20s(%.5d): %.200s", file, line_nr, desc);
    switch (MessageBox(NULL, buf, "Assert Failed!", MB_ABORTRETRYIGNORE | MB_SYSTEMMODAL))
    {
      case IDRETRY:
        return 0;
      case IDIGNORE:
        *ignore = 1;
        return 0;
      case IDABORT:
       return 1;
    }

	/* to satisfy microsoft */
	return 1;
}

