#ifndef __GEZASSERT_H__
#define __GEZASSERT_H__

/* provides extended assert function on win32 platforms */

#ifdef _DEBUG

  /* custom assert function prototype */
  int AssertFunction(int, char*, int, char*, char*);

  #define ASSERT(e, desc)                      \
  {                                               \
    static char ignoreAlways = 0;                 \
    if ((e) == 0)                                 \
    {                                             \
      if (ignoreAlways == 0)                      \
      {                                           \
        if (AssertFunction((int)(e), desc,        \
            __LINE__, __FILE__, &ignoreAlways))   \
        {                                         \
		__asm {                      \
            int 3  /* break execution */    \
		}                                      \
        }                                         \
      }                                           \
    }                                             \
  }

#else

  #define ASSERT(e, desc)
  
#endif

#endif /* ifndef __GEZASSERT_H__ */

