/*
  the camera class
*/

#ifndef __GEZCAMERA_H__
#define __GEZCAMERA_H__

#include <windows.h>

#include "Error.h"
#include "Renderer.h"
#include "Map.h"
#include "Vector.h"
#include "GL/gl.h"

#ifndef NULL
#define NULL 0x0L
#endif

class Camera
{
  private:
	bool	benchmark,
			shade_switch,
			pm_switch,
			text_switch,
			cull_switch;

    float fSpeed;
    float fAngularSpeed;

	Vector3f vVelocity,
                vAngularVelocity,
				vPos, vRot, vLook, vPitchAxis, vUp;

    void *app; // pointer to application object (input state)
    
    /* fps measurement */
    unsigned int frames;
    long long fps_start;
    long long pf_frequency;
    float fSecsPerFrame;
	
	bool free_move;
    
  protected:
  public:
  
    Renderer *renderer; /* render interface */
    Map      *map;
    
    float fps;

    void SetApp(void *app);

    Camera();
    Camera(float, float, float);
    ~Camera();
    
    GEZERROR Initialize();
    GEZERROR SetRenderer(Renderer *renderer);
    Renderer* GetRenderer();
    
    void RotateCam(float yaw, float pitch);

    GEZERROR Render();
    GEZERROR LoadMap(char *fname);
};

#endif /* ifndef __GEZCAMERA_H__ */

