/*
  frustum culling
*/

#ifndef __CULLING_H__
#define __CULLING_H__

#define NUM_PLANES 6

enum PlaneIndex {
	RIGHT,
	LEFT,
	FARPLANE,
	NEARPLANE,
	BOTTOM,
	TOP,
};

enum Halfspace
{
	NEGATIVE = -1,
	ON_PLANE = 0,
	POSITIVE = 1, /* positive means in front of plane */
};

enum Visibility
{
	NONE,
	PARTIAL,
	FULL
};

struct Plane 
{
	float a, b, c, d;
};

struct Point
{
	float x, y, z;
};

Visibility isVisibleQuad(const Plane cull_planes[NUM_PLANES], const Point p[4]);
Visibility checkPlaneSide(const Plane &plane, const Point p[4]);
Halfspace __forceinline ClassifyPoint(const Plane & plane, const Point & pt);
float DistanceToPoint(const Plane & plane, const Point & pt);
void GetCullingPlanes(Plane cull_planes[NUM_PLANES]);

#endif // #ifndefn __CULLING_H__