/*
  fast conversion functions
*/


#ifndef __FASTMATH_H__
#define __FASTMATH_H__


typedef union {
  int i;
  float f;
} INTORFLOAT;


int __forceinline fast_ftoi(float *f)
{
  INTORFLOAT n;
  INTORFLOAT bias;
  
  bias.i = (((23 + 127)) << 23) + (1 << 22);
  n.f    = *f;
  
  n.f += bias.f;
  n.i -= bias.i;
  
  return n.i;
}

__inline long int
lrint (double flt)
{
  int intgr;
  _asm
  {
      fld flt
      fistp intgr
  } ;
  return intgr ;
}

__inline long int
lrintf (float flt)
{
   int intgr;
   _asm
  {
    fld flt
    fistp intgr
  } ;
  return intgr ;
}

#endif